/// Define how to parse response json
/// If you want to support more, PR is welcome
enum Parser {
  /// same as [JsonSerializable] but with toMap and fromMap functions.
  MapSerializable,

  /// Each model class must provide 'factory T.fromJson(Map<String, dynamic> json)'
  /// For more detail, please visit 'https://github.com/trevorwang/retrofit.dart#type-conversion'
  JsonSerializable,

  /// Each model class must add annotation '@jsonSerializable'
  /// For more detail, please visit 'https://github.com/k-paxian/dart-json-mapper'
  DartJsonMapper,

  DioPAMapper,
}

typedef DioPASerializer = Map<String, dynamic> Function(String name, dynamic data);

typedef DioPADeserializer = dynamic Function(String name, Map<String, dynamic> value);
